classification
Title: Possible refcount issues in the compiler
Type: resource usage Stage: resolved
Components: Interpreter Core Versions: Python 3.8, Python 3.7, Python 3.6, Python 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: serhiy.storchaka Nosy List: miss-islington, serhiy.storchaka
Priority: normal Keywords: patch

Created on 2018-03-24 12:32 by serhiy.storchaka, last changed 2018-04-01 07:42 by serhiy.storchaka. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 6209 merged serhiy.storchaka, 2018-03-24 12:34
PR 6217 merged miss-islington, 2018-03-24 20:42
PR 6321 merged serhiy.storchaka, 2018-03-31 20:22
PR 6322 merged serhiy.storchaka, 2018-03-31 20:24
PR 6323 merged serhiy.storchaka, 2018-03-31 20:27
PR 6327 merged miss-islington, 2018-03-31 21:29
Messages (7)
msg314365 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2018-03-24 12:32
There are several possible reference leaks in compiler.c. When implicit (in VISIT* or ADDOP_* macros) "return" is occurred between creating a new object and ADDOP_N, there is a possible reference leaks. ADDOP_O followed by Py_DECREF contains a possible reference leaks.

And in compiler_from_import() names can be decrefed twice.

The following PR fixes these issues.
msg314384 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2018-03-24 20:42
New changeset a95d98607efe0c43475b354543e49bf8e240bc6f by Serhiy Storchaka in branch 'master':
bpo-33132: Fix reference counting issues in the compiler. (GH-6209)
https://github.com/python/cpython/commit/a95d98607efe0c43475b354543e49bf8e240bc6f
msg314386 - (view) Author: miss-islington (miss-islington) Date: 2018-03-24 21:27
New changeset 471364b4d977fc31bdf3012912954f24e4867d52 by Miss Islington (bot) in branch '3.7':
bpo-33132: Fix reference counting issues in the compiler. (GH-6209)
https://github.com/python/cpython/commit/471364b4d977fc31bdf3012912954f24e4867d52
msg314747 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2018-03-31 20:54
New changeset 25c869edd665cba7187910c5b151a0016fec4754 by Serhiy Storchaka in branch '3.6':
[3.6] bpo-33132: Fix reference counting issues in the compiler. (GH-6209). (GH-6321)
https://github.com/python/cpython/commit/25c869edd665cba7187910c5b151a0016fec4754
msg314748 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2018-03-31 21:29
New changeset aa8e51f5ebb2a71c76059f050de01fc3c985376a by Serhiy Storchaka in branch 'master':
bpo-33132: Fix more reference counting issues in the compiler. (GH-6323)
https://github.com/python/cpython/commit/aa8e51f5ebb2a71c76059f050de01fc3c985376a
msg314750 - (view) Author: miss-islington (miss-islington) Date: 2018-03-31 23:41
New changeset 9e96e7b24e4d3ff4dce4f24c4e469cd5460712c9 by Miss Islington (bot) in branch '3.7':
bpo-33132: Fix more reference counting issues in the compiler. (GH-6323)
https://github.com/python/cpython/commit/9e96e7b24e4d3ff4dce4f24c4e469cd5460712c9
msg314766 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2018-04-01 07:26
New changeset 72f3e0887500e00867fa16ce5aaab12fae853b63 by Serhiy Storchaka in branch '2.7':
[2.7] bpo-33132: Fix reference counting issues in the compiler. (GH-6209). (GH-6322)
https://github.com/python/cpython/commit/72f3e0887500e00867fa16ce5aaab12fae853b63
History
Date User Action Args
2018-04-01 07:42:56serhiy.storchakasetstatus: open -> closed
stage: patch review -> resolved
resolution: fixed
versions: + Python 2.7
2018-04-01 07:26:35serhiy.storchakasetmessages: + msg314766
2018-03-31 23:41:30miss-islingtonsetmessages: + msg314750
2018-03-31 21:29:48miss-islingtonsetpull_requests: + pull_request6041
2018-03-31 21:29:39serhiy.storchakasetmessages: + msg314748
2018-03-31 20:54:16serhiy.storchakasetmessages: + msg314747
2018-03-31 20:27:01serhiy.storchakasetpull_requests: + pull_request6039
2018-03-31 20:24:02serhiy.storchakasetpull_requests: + pull_request6038
2018-03-31 20:22:44serhiy.storchakasetpull_requests: + pull_request6037
2018-03-24 21:27:08miss-islingtonsetnosy: + miss-islington
messages: + msg314386
2018-03-24 20:42:53miss-islingtonsetpull_requests: + pull_request5962
2018-03-24 20:42:42serhiy.storchakasetmessages: + msg314384
2018-03-24 12:34:20serhiy.storchakasetkeywords: + patch
stage: patch review
pull_requests: + pull_request5954
2018-03-24 12:32:25serhiy.storchakacreate